import type { NextPage } from 'next';
import React from 'react';
import { useSelector } from 'react-redux'
import { MainLayout } from '../layouts/Customer';
import { CardStock, SkeletonStock, BoxScroll, Box, MottoBlock, CategoriesButton, CategoriesSkeleton } from '../components';
import { useAppDispatch } from '../redux/store';

import { fetchStoke, selectStokeData } from '../redux/stoke/';
import { fetchCategories, selectCategoriesData } from '../redux/categories';
import { fetchPizza, selectPizzaData } from '../redux/pizza';



const Home: NextPage = () => {
  const dispatch = useAppDispatch();

  React.useEffect(() => {
    dispatch( fetchStoke() );
    dispatch( fetchCategories() );
    dispatch( fetchCategories() );
  }, [1]);

  const { items, status } = useSelector(selectStokeData);
  const { categories_items, categories_status } = useSelector(selectCategoriesData);

  const stokes = items.map((obj, index) => <CardStock key={index} {...obj} />);
  const skeletonsStoke = [...new Array(4)].map((_, index) => <SkeletonStock key={index} />);

  const categories = categories_items.map((obj, index) => <CategoriesButton key={index} {...obj}/> );
  const categoriesSkeleton = [...new Array(6)].map((_, index) => <CategoriesSkeleton key={index} />);

  const pizza = categories_items.map((obj, index) => <CategoriesButton key={index} {...obj}/> );
  //const categoriesSkeleton = [...new Array(6)].map((_, index) => <CategoriesSkeleton key={index} />);

  return (
    <MainLayout>
      <BoxScroll>
        {status === 'loading' ? skeletonsStoke : stokes}
      </BoxScroll>
      <BoxScroll>
        <MottoBlock/>
      </BoxScroll>
      <BoxScroll>
        {categories_status === 'loading' ? categoriesSkeleton : categories}
      </BoxScroll>
      <Box>
        pizza
      </Box>
    </MainLayout>
  )
}

export default Home
